/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */


#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>
#include <syssvc/serial.h>

#include "kernel_cfg.h"
#include "serial_receive.h"
#include "target_io.h"

#define SERIAL_PORTID	(1)

void main_task(intptr_t exinf)
{
	ER ercd;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "Sensing push switch program starts.");
	
	/* VA|[g̐ݒ */
	ercd = serial_opn_por(SERIAL_PORTID);
	ercd = serial_ctl_por(SERIAL_PORTID , IOCTL_CRLF);
	
	while(1)
	{
		ercd = act_tsk(SERIAL_TASK);
		slp_tsk();
	}
}

void serial_task(intptr_t exinf)
{
	ER ercd;
	char_t buf;
	
	syslog(LOG_INFO , "Please input character:");
	
	/* A[nhł̊ĎJn */
	sta_alm(TMOUT_ALM , 5000);
	
	/* VA͂󂯎胋[vobN */
	ercd = serial_rea_dat(SERIAL_PORTID , &buf , 1);
	
	if(ercd > 0)
	{
		syslog(LOG_INFO , "Input charcter = %c" , buf);
	}
	else if(ercd == E_RLWAI)
	{
		stp_alm(TMOUT_ALM);
		syslog(LOG_INFO , "Timeout!");
	}
	else
	{
		/* Ȃ */
	}
	
	wup_tsk(MAIN_TASK);
}

void alarm_handler(intptr_t exinf)
{
	(void)irel_wai(SERIAL_TASK);
}
