/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/* LEDvO */

#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>

#include "kernel_cfg.h"
#include "led_control.h"
#include "target_io.h"

/*
 *  ԕϐ
 *
 *  XCb`͂Ő؂ւ
 */

uint_t mode;
enum
{
	BLINK_CYCHDR = 1 ,
	BLINK_TASK ,
	MODE_MAX
};

void led_task(intptr_t exinf)
{
	ER ercd;
	
	while(1)
	{
		ercd = dly_tsk(1000);
		gpio_set_led(false);
		ercd = dly_tsk(2000);
		gpio_set_led(true);
	}
	
	ercd = ext_tsk();
	assert(ercd == ercd);
}

void main_task(intptr_t exinf)
{
	volatile uint_t psw = 0u , pre_psw = 0u;
	ER ercd;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* [h̐ݒ */
	mode = BLINK_CYCHDR;
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "LED control program starts.");
	
	/* [hI */
	while(1)
	{
		switch(mode)
		{
			case BLINK_CYCHDR:
				ercd = ter_tsk(LED_TASK);
				ercd = sta_cyc(LED_CYC);
				break;
			case BLINK_TASK:
				ercd = stp_cyc(LED_CYC);
				ercd = act_tsk(LED_TASK);
				break;
			default:
				assert(1 == 1);
				break;
		}
		
		/* XCb`ω̌o[v */
		do
		{
			ercd = dly_tsk(5);
			pre_psw = psw;
			/* PSW2L->H̎ɌoƔf */
			psw = gpio_get_psw();
		}while((psw == pre_psw) || ((psw & PSW2) == 0));
		
		/* [hύX */
		mode += 1u;
		if(mode >= MODE_MAX)
		{
			mode = 1u;
		}
	}
}

void cyclic_handler(intptr_t exinf)
{
	static bool_t led_on = false;
	
	/* LED𔽓] */
	if(led_on == false)
	{
		led_on = true;
		gpio_set_led(true);
	}
	else
	{
		led_on = false;
		gpio_set_led(false);
	}
}

