/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *  XCb`͂CxgtOŒʒmvÕ\[Xt@C
 */

#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>

#include "kernel_cfg.h"
#include "wait_psw.h"
#include "target_io.h"


void main_task(intptr_t exinf)
{
	ER ercd;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "Sensing push switch program starts.");
	
	ercd = sta_cyc(PSW_CYC);
}

void psw2_task(intptr_t pswptn)
{
	ER ercd;
	
	while(slp_tsk() == E_OK)
	{
		syslog(LOG_INFO , "switch pattern %x pushed" , pswptn);
	}
	
	(void)ext_tsk();
}

void psw3_task(intptr_t pswptn)
{
	syslog(LOG_INFO , "switch pattern %x pushed" , pswptn);
	
	(void)ext_tsk();
}


void cyclic_handler(intptr_t exinf)
{
	static volatile uint_t psw = 0 , pre_psw = 0;
	ER ercd;
	
	/* XCb`ω̌o */
	pre_psw = psw;
	psw = gpio_get_psw();
	
	/* lωƂɎɌoƔf */
	if(psw != pre_psw)
	{
		if((psw & PSW2) != 0u)
		{
			ercd = iwup_tsk(PSW2_TASK);
		}
		else if((psw & PSW3) != 0u)
		{
			ercd = iact_tsk(PSW3_TASK);
		}
		else
		{
			/* Ȃ */
		}
	}
	
}

