/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/* A/Dϊ̊ݏvO */

#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>
#include "lpc2388.h"

#include "kernel_cfg.h"
#include "ad_interrupt.h"
#include "target_io.h"

void main_task(intptr_t exinf)
{
	uint_t vr2;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "A/D converter interrupt program starts.");
	
	/* 荞݃Rg[ADϊ튄݂Lɂ */
	if(ena_int(INTNO_AD0) != E_OK)
	{
		syslog(LOG_NOTICE , "Failed to enable interrupt.exit.");
		ext_ker();
	}
	/* ADϊ푤݂̊Lɂ */
	adc_ena_int();
	
	while(1)
	{
		vr2 = adc_get_vr2();
		syslog(LOG_INFO , "Digital value is %u" , vr2);
		(void)dly_tsk(1000);
	}
}

void ad_isr(intptr_t exinf)
{
	/*
	 *  A/DRo[^̕ϊtONA(WX^ǂނ)
	 *  œK}~邽߂ɕϐvolatiles
	 */
	volatile uint32_t ad0cr0_reg = sil_rew_mem((void *)AD0DR0);
	
	syslog(LOG_INFO , "A/D converter interrupt occur.");
}

