/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */


#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>

#include "kernel_cfg.h"
#include "vr2_read.h"
#include "target_io.h"

void display_task(intptr_t exinf)
{
	ER ercd;
	uint_t vr_data;
	
	while(1)
	{
		while(prcv_dtq(VR2VAL_DTQ , (intptr_t *)&vr_data) == E_OK)
		{
			syslog(LOG_INFO , "VR2 value is %d" , vr_data);
		}
		syslog(LOG_INFO , "Data empty.");
		dly_tsk(3000);
	}
	
	ercd = ext_tsk();
	assert(ercd == ercd);
}

void main_task(intptr_t exinf)
{
	ER ercd;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "Reading VR2 program starts.");
	
	ercd = sta_cyc(READ_CYC);
	ercd = act_tsk(DISP_TASK);
	
	ercd = ext_tsk();
	assert(ercd == ercd);
}

void cyclic_handler(intptr_t exinf)
{
	uint_t vr2_value;
	
	vr2_value = adc_get_vr2();
	
	(void)ipsnd_dtq(VR2VAL_DTQ , (intptr_t)vr2_value);
}

