/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *  XCb`ƉϒR̒lǂݏovO
 */

#include <kernel.h>
#include <t_syslog.h>
#include <syssvc/syslog.h>

#include "kernel_cfg.h"
#include "read_multi_io.h"
#include "target_io.h"

/*
 *  ǂݏol̊i[̈
 */
typedef struct
{
	T_MSG *msg;
	uint_t vr2_value;
	uint_t psw_state;
} IO_DATA;

IO_DATA read_value;

void main_task(intptr_t exinf)
{
	ER ercd;
	
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "Reading VR2 and PSW program starts.");
	
	ercd = act_tsk(READ_TASK);
	ercd = act_tsk(DISP_TASK);
	
	ercd = ext_tsk();
	assert(ercd == ercd);
}

void display_task(intptr_t exinf)
{
	ER ercd;
	IO_DATA *msg;
	
	while(1)
	{
		while(rcv_mbx(IO_MBX , (T_MSG **)&msg) == E_OK)
		{
			syslog(LOG_INFO , "VR2 value is %d" , msg->vr2_value);
			syslog(LOG_INFO , "PSW value is %x" , msg->psw_state);
			wup_tsk(READ_TASK);
		}
	}
	
	ercd = ext_tsk();
	assert(ercd == ercd);
}

void read_task(intptr_t exinf)
{
	while(1)
	{
		read_value.vr2_value = adc_get_vr2();
		read_value.psw_state = gpio_get_psw();
	
		if(snd_mbx(IO_MBX , (T_MSG *)&read_value) == E_OK)
		{
			(void)slp_tsk();
		}
		(void)dly_tsk(2000);
	}
}

