/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/* Œ蒷v[̃eXgvO */

#include <kernel.h>
#include <syssvc/syslog.h>
#include "memory_pool.h"
#include "kernel_cfg.h"

#include "target_io.h"

void main_task(intptr_t exinf)
{
	/* syslog̐ݒ */
	syslog_msk_log(LOG_UPTO(LOG_INFO) , LOG_UPTO(LOG_EMERG));
	
	/* Nʕ\ */
	syslog(LOG_NOTICE, "Memory pool test program starts.");
	
	(void)act_tsk(TASK1);
	(void)act_tsk(TASK2);
	
	(void)ext_tsk();
}

void task1(intptr_t exinf)
{
	static volatile uint_t psw = 0 , pre_psw = 0;
	intptr_t *p;
	
	while(1)
	{
		/* XCb`ω̌o */
		pre_psw = psw;
		psw = gpio_get_psw();
		
		/* lωƂɎɌoƔf */
		if(psw != pre_psw)
		{
			if((psw & PSW2) != 0u)
			{
				/* ̈̎擾C̈悪ȂƂ͑҂ԂɂȂ */
				(void)get_mpf(MPF , (void **)&p);
				syslog(LOG_INFO , "Get memory area(%x)!" , p);
				(void)snd_dtq(DTQ , (intptr_t)p);
			}
		}
		else
		{
			dly_tsk(10);
		}
	}
}

void task2(intptr_t exinf)
{
	static volatile uint_t psw = 0 , pre_psw = 0;
	intptr_t *p;
	
	while(1)
	{
		/* XCb`ω̌o */
		pre_psw = psw;
		psw = gpio_get_psw();
		
		/* lωƂɎɌoƔf */
		if(psw != pre_psw)
		{
			if((psw & PSW3) != 0u)
			{
				if(prcv_dtq(DTQ , (intptr_t *)&p) == E_OK)
				{
					/* ̈̉Cl҂Ă^XNΑ҂ */
					syslog(LOG_INFO , "Memory address is %x" , p);
					(void)rel_mpf(MPF , (void *)p);
					syslog(LOG_INFO , "Release memory area!");
				}
			}
		}
		else
		{
			dly_tsk(10);
		}
	}
}

