/*!
 *	\file	FelicaW[ RC-S620Cu
 *	\author	Meika Sugimoto
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

#include <kernel.h>
#include <sil.h>
#include "kernel_cfg.h"
#include <t_syslog.h>
#include "syssvc/serial.h"

#include "lpc2388.h"
#include "rc_s620.h"

#include <string.h>

/*
 *  }N`
 */

/* zTCYZo}N */
#define ARRAY_SIZE(array)	(sizeof((array))/sizeof(array[0]))

/* ʐMKiwR[h */
#define ISOIEC18092_212KBPS					(0x01)

/* zXgR}hR[hCTuR}hR[h */
#define HOSTCOMMAND_INLISTPASSIVETARGET		(0xD4)
#define HOSTSUBCOMMAND_INLISTPASSIVETARGET	(0x4A)

#define HOSTCOMMAND_CONTROLED				(0xD4)
#define HOSTSUBCOMMAND_CONTROLED			(0x1C)

#define HOSTCOMMAND_RFCONFIGURATION			(0xD4)
#define HOSTSUBCOMMAND_RFCONFIGURATION		(0x32)

/* X|XR}hR[h */
#define RESPONSE_INLISTPASSIVETARGET		\
			(HOSTCOMMAND_INLISTPASSIVETARGET + 1)
#define SUBRESPONSE_INLISTPASSIVETARGET		\
			(HOSTSUBCOMMAND_INLISTPASSIVETARGET + 1)

#define RESPONSE_CONTROLED		\
			(HOSTCOMMAND_CONTROLED + 1)
#define SUBRESPONSE_CONTROLED		\
			(HOSTSUBCOMMAND_CONTROLED + 1)

#define RESPONSE_RFCONFIGURATION		\
			(HOSTCOMMAND_RFCONFIGURATION + 1)
#define SUBRESPONSE_RFCONFIGURATION		\
			(HOSTSUBCOMMAND_RFCONFIGURATION + 1)


/* R}h߂}N */
#define HOSTPACET_LEN(command_len)	((command_len) + 7)
#define RESPONSE_LEN(resdata_len)	((resdata_len) + 9)

/*
 *  ֐̃vg^Cv錾
 */
static void
rc_s620_make_hostpacket(const uint8_t *data , int_t dlen , uint8_t *buf);

static uint8_t
rc_s620_calc_checksum(const uint8_t *data , int_t dlen);

static ER_UINT rc_s620_execute_command
(const uint8_t *command , uint8_t command_len ,
	uint8_t response_len , uint8_t *buf);

/*
 *  pPbg\ʂȒl
 */
const uint8_t RC_620S_PREAMBLE = 0x00;
const uint8_t RC_620S_SOP1 = 0x00;	/* SOP = start of packet */
const uint8_t RC_620S_SOP2 = 0xFF;
const uint8_t RC_620S_POSTAMBLE = 0x00;

/* ǂݎID */
uint_t const rc_s620_id_length = 8u;

/* ^CAEg */
const uint8_t rc_s620_tmout = 300;

/* ACKpPbg */
const uint8_t rc_620s_ack[] = { 0x00 , 0x00 , 0xFF , 0x00 , 0xFF, 0x00 };


/*
 *  t@CO[oϐ
 */

/* APIĂяo^XNID */
static ID rc_s620_caller_tskid;

/*!
 *  \brief		zXgpPbg̑g
 *	\param		data [in] pPbg̃f[^
 *	\param		dlen [in] f[^
 *	\return		Ȃ
 *	\note		`FbNT2̕␔
 */
static uint8_t
rc_s620_calc_checksum(const uint8_t *data , int_t dlen)
{
	uint16_t sum = 0x00;
	int_t i;
	
	for(i = 0 ; i < dlen ; i++)
	{
		sum = (sum + data[i]) & 0xFF;
	}
	
	return (uint8_t)((~sum + 1) & 0xFF);
}

/*!
 *  \brief		zXgpPbg̑g
 *	\param		data [in] pPbg̃f[^
 *	\param		dlen [in] f[^̒
 *	\param		buf [out] zXgpPbgf[^ޗ̈ւ̃|C^
 *	\return		Ȃ
 *	\attention	bufNULLłȂƂ͌Ăяoŕۏ؂邱ƁD
 */
static void rc_s620_make_hostpacket
	(const uint8_t *data , int_t dlen , uint8_t *buf)
{
	/* Œl̐ݒ */
	buf[0] = RC_620S_PREAMBLE;
	buf[1] = RC_620S_SOP1;
	buf[2] = RC_620S_SOP2;
	buf[dlen + 5] = RC_620S_POSTAMBLE;
	
	/* f[^̐ݒƃf[^̃`FbNTvZ */
	buf[3] = dlen;
	buf[4] = ~dlen + 1;
	
	/* f[^̃Rs[ */
	memcpy(&buf[5] , data , dlen);
	
	/* f[^̃`FbNTvZ */
	buf[dlen + 5] = rc_s620_calc_checksum(data , dlen);
}

ER rc_s620_initialize(void)
{
	/* VAhCõI[vƐݒ */
	if((serial_opn_por(RC_S620_SIO_ID) != E_OK)
		|| (serial_ctl_por(RC_S620_SIO_ID , IOCTL_NULL) != E_OK))
	{
		/* VAhCoI[vłȂ΃Vbg_E */
		syslog(LOG_ALERT , "[ Felica communication ] Serial driver can not open.");
		return E_SYS;
	}
	
	/* sݒ */
	sil_wrw_mem((void *)PINSEL1 , 
				sil_rew_mem((void *)PINSEL1) | 0x003C0000);
	
	return E_OK;
}

void rc_s620_terminate(void)
{
	/* VAhCõN[Y */
	(void)serial_opn_por(RC_S620_SIO_ID);
}

bool_t rc_s620_search_target(uint8_t *target_id)
{
	/* Payload̎dlISO/IEC18092dlɋLqĂ */
	const uint8_t iltp_command[] =
		{
			HOSTCOMMAND_INLISTPASSIVETARGET ,		/* R}h */
			HOSTSUBCOMMAND_INLISTPASSIVETARGET ,	/* TuR}h */
			0x01 , ISOIEC18092_212KBPS ,			/* ^[QbgߑƒʐMKiw */
			0x00 , 0xff , 0xff , 0x00 , 0x00		/* yC[h */
		};
	uint8_t buf[RESPONSE_LEN(22)];
	ER_UINT erut;
	
	if((erut = rc_s620_execute_command(iltp_command ,
			ARRAY_SIZE(iltp_command) , RESPONSE_LEN(22) , buf)) > 0)
	{
		memcpy(target_id , &buf[6] , rc_s620_id_length);
	}
	
	return (erut == 1)? false : true;
}

bool_t rc_s620_RFConfiguration
(uint8_t item , const uint8_t *param , uint_t len)
{
	/* őł16byete܂ */
	uint8_t rfconf_command[16] =
		{
			HOSTCOMMAND_RFCONFIGURATION ,		/* R}h */
			HOSTSUBCOMMAND_RFCONFIGURATION 	/* TuR}h */
		};
	uint8_t buf[RESPONSE_LEN(16)];
	
	rfconf_command[2] = item;
	memcpy(&rfconf_command[3] , param , len);
	
	return (rc_s620_execute_command(rfconf_command ,
			(len + 3u) , RESPONSE_LEN(0) ,  buf) >= 0)? true : false;
}

static ER_UINT rc_s620_execute_command
(const uint8_t *command , uint8_t command_len ,
	uint8_t response_len , uint8_t *buf)
{
	int len;
	
	/* Ăяõ^XNIDۑ */
	if(get_tid(&rc_s620_caller_tskid) != E_OK)
	{
		return false;
	}
	
	/* R}hpPbg̑g */
	rc_s620_make_hostpacket(command , command_len , buf);
	
	if(serial_wri_dat(RC_S620_SIO_ID , (const char_t *)buf ,
			HOSTPACET_LEN(command_len)) < 0)
	{
		/* G[Ȃ珈I */
		return false;
	}
	
	/* M^CAEgĎA[N */
	(void)sta_alm(RC_S620_TMOUT_ALM , rc_s620_tmout);
	
	/* ACKR}hM */
	if((len = serial_rea_dat(RC_S620_SIO_ID , buf , ARRAY_SIZE(rc_620s_ack))) < 0)
	{
		(void)stp_alm(RC_S620_TMOUT_ALM);
		return false;
	}
	
	/* ACK΃X|XM */
	if((response_len = serial_rea_dat(RC_S620_SIO_ID ,
			buf , response_len)) > 0)
	{
		if(stp_alm(RC_S620_TMOUT_ALM) != E_OK)
		{
			return false;
		}
	}
	else
	{
		/* ACKĂȂ̂ŃG[ */
		return false;
	}
	
	memmove(buf , &buf[5] , response_len);
	return response_len - 9;
}


void rc_620s_tmout_hanlder(intptr_t exinf)
{
	/* VAM҂̃^XN̑҂Ԃ */
	(void)irel_wai(rc_s620_caller_tskid);
}

