/*!
 *	\file	ȈՃ^CR[_[
 *	\author	Meika Sugimoto
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

#include <kernel.h>
#include <sil.h>
#include <t_syslog.h>
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "lpc2388.h"

#include "time_recorder.h"
#include "rc_s620.h"
#include "extboard.h"

/* T[rXR[̌Ăяo */
#define CALLSVC(expression)					\
	{										\
		ER ercd;							\
											\
		ercd = (expression);				\
		if(ercd < 0)						\
		{									\
			system_error(ercd);				\
		}									\
	}

/*
 *  ^CR[_[̓샂[h
 */
typedef enum
{
	START_WORK = 1,
	FINISH_WORK
} TIME_RECODER_MODE;

static TIME_RECODER_MODE recmode;

/*
 *  ֐
 */
static void system_error(ER ercd);

static void system_error(ER ercd)
{
	ID tskid;
	
	/* G[̕\ */
	(void)get_tid(&tskid);
	syslog(LOG_ERROR ,
		"System error occured. Error code = %d , Task ID = %u." , ercd , tskid);
	
	ext_ker();
}


void time_recorder_initialize(intptr_t exinf)
{
	/* syslog̏ */
	syslog_msk_log(LOG_UPTO(LOG_DEBUG) , LOG_UPTO(LOG_ERROR));
	
	syslog(LOG_NOTICE , "[ Log ] Initialize task activate.");
	
	/* LED_ */
	extboard_set_led(LED1 , true);
	extboard_set_led(LED2 , false);
	
	/* e^XNN */
	CALLSVC(act_tsk(FELICA_COMM_TASK));
	CALLSVC(act_tsk(IO_TASK));
	CALLSVC(act_tsk(RECORD_TASK));
	
	/* ϐ̏ */
	recmode = START_WORK;
	
	CALLSVC(ext_tsk());
}

void felica_communication_task(intptr_t exinf)
{
	uint8_t id[8];
	bool_t erlen;
	uint_t felica_id_lower , felica_id_upper;
	
	syslog(LOG_INFO , "[ Log ] Felia communication task start.");
	
	/* RC-S620̏ */
	CALLSVC(rc_s620_initialize());
	
	/* ʐMp[^̐ݒCRFConfigurationR}h𔭍s */
	if(rc_s620_rfconf_varioustiming() == false)
	{
		syslog(LOG_NOTICE , "[ Error Info ] Various timing can not set.");
	}
	
	if(rc_s620_rfconf_maxretry() == false)
	{
		syslog(LOG_NOTICE , "[ Error Info ] Max entry can not set.");
	}
	
	if(rc_s620_rfconf_addwaitingtime() == false)
	{
		syslog(LOG_NOTICE , "[ Error Info ] Add waiting timing can not set.");
	}
	
	/* Felica`bv|[O */
	while(1)
	{
		/* InListPassiveTargetR}h̔s */
		if((erlen = rc_s620_search_target(id)) == true)
		{
			syslog(LOG_INFO , "[ Log ] Felica chip caught.");
			
			/* oCg񂩂4byte~2 */
			felica_id_upper = ((uint32_t)id[0] << 24) | ((uint32_t)id[1] << 16)
					| ((uint32_t)id[2] << 8) | ((uint32_t)id[3] << 0);
			felica_id_lower = 
				((uint32_t)id[4] << 24) | ((uint32_t)id[5] << 16)
					| ((uint32_t)id[6] << 8) | ((uint32_t)id[7] << 0);
			
			/* ʐM^XNID𑗐M */
			CALLSVC(snd_dtq(FELICA_ID , (uintptr_t)felica_id_upper));
			CALLSVC(snd_dtq(FELICA_ID , (uintptr_t)felica_id_lower));
			
			/* FFelica`bvFłȂ܂ő҂ */
			while(rc_s620_search_target(id) == true)
				;
		}
		
		CALLSVC(dly_tsk(50));
	}
	
	CALLSVC(ext_tsk());
}

void io_task(intptr_t exinf)
{
	/* XCb`mp̃f[^ */
	uint_t pre_psw = PSW_OFF , psw = PSW_OFF;
	
	syslog(LOG_INFO , "[ Log ] I/O task start.");
	
	/* 20msecŃ|[O */
	while(1)
	{
		/* XCb`ω̌o */
		pre_psw = psw;
		psw = extboard_get_psw();
		
		/* lωƂɎɌoƔf */
		if((psw != pre_psw)
			&& (psw == PSW_ON))
		{
			syslog(LOG_INFO , "[ Log ] Switch pushed.");
			/*
			 *  o΂Ƒދ΂؂ւ
			 */
			 
			 /* FelicaǂݏoƂ̔r */
			CALLSVC(wai_sem(RECORD_MODE));
			
			/* [h؂ւ */
			recmode = (recmode == START_WORK)?
							FINISH_WORK : START_WORK;
			
			/* r̉ */
			CALLSVC(sig_sem(RECORD_MODE));
			
			/* [h؂ւ */
			if(recmode == START_WORK)
			{
				extboard_set_led(LED1 , true);
				extboard_set_led(LED2 , false);
			}
			else
			{
				extboard_set_led(LED1 , false);
				extboard_set_led(LED2 , true);
			}
		}
		
		CALLSVC(dly_tsk(20));
	}
	
	CALLSVC(ext_tsk());
}

void record_task(intptr_t exinf)
{
	const char *modelog_str;
	const char *str_start_work = "start work";
	const char *str_finish_work = "finish work";
	uint_t felica_id_lower , felica_id_upper;
	
	syslog(LOG_INFO , "[ Log ] Record task start.");
	
	while(1)
	{
		/* rŃ[hςȂ悤ɔr */
		CALLSVC(wai_sem(RECORD_MODE));
		
		/* f[^M */
		if(prcv_dtq(FELICA_ID , (intptr_t *)&felica_id_upper) == E_OK)
		{
			CALLSVC(rcv_dtq(FELICA_ID , (intptr_t *)&felica_id_lower));
			
			/* [hǂݏo */
			modelog_str = (recmode == START_WORK)?
							str_start_work : str_finish_work;
			
			syslog(LOG_NOTICE , "[ Record ] <%s> ID : %x%x" , 
						modelog_str , felica_id_upper , felica_id_lower);
		}
		/* rI */
		CALLSVC(sig_sem(RECORD_MODE));

	}
	
	CALLSVC(ext_tsk());
}
